package fr.inway;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.JFrame;

import org.xsocket.connection.ConnectionUtils;
import org.xsocket.connection.IServer;
import org.xsocket.connection.Server;

/*
 * by PhilFlash - http://philflash.inway.fr 
 * - Updated : February 2009 (Updated with xSocket 2.4.3)
 * - Initial version : November 2008 (Based on xSocket 2.2)
 * Based on xSocket : http://xsocket.sourceforge.net/
 * Inspired by :
 * - Building a Multi-user Chat Server with xSocket, Java, and Flash CS3
 *   http://giantflyingsaucer.com/blog/?p=224
 * - Policy Server from SmartFoxServer 
 *   http://www.smartfoxserver.com/whitepapers/fp_security/index.html
 */

public class PolicyServer {

    private boolean useUI = true;
    private String policyData;
    private JFrame gui;
    
    private IServer socketServer = null;
    
    public PolicyServer(boolean useUI, boolean showTrace)
    {
        this.useUI = useUI;
        
        try
        {
            policyData = new String(readFile("policy.xml"));
              
            socketServer = new Server(843, new PolicyProtocolHandler(policyData, showTrace));
  
    		ConnectionUtils.start(socketServer);
    		ConnectionUtils.registerMBean(socketServer);
            
            showInfo();
        }
        catch(Exception ex)
        {
            Logger.getLogger(PolicyServer.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("EXIT!");
            System.exit(-1);
        }
    }
    
    private void showInfo()
    {
    	
    	//System.out.println(System.getProperty("user.dir"));
    	/* if (socketServer != null)
    	{
    		System.out.println("Address="+socketServer.getLocalAddress());
    	}
    	*/
        if(useUI)
        {
            gui = new ServerGUI();
            gui.setVisible(true);
        } else
        {
            System.out.println(".:::::::::::::::::::::::::::::.");
            System.out.println(".: Socket Policy Server      :.");
            System.out.println(".: Version 1.05 by PhilFlash :.");
            System.out.println(".:::::::::::::::::::::::::::::.");
        }
    }
    
    private String readFile(String fileName) throws IOException
	{
	    File file = new File(fileName);
	    int size = (int)file.length();
	    byte rawData[] = new byte[size];
	    FileInputStream fis = new FileInputStream(file);
	    fis.read(rawData);
	    return new String(rawData);
	}

    public ServerGUI getGUI()
    {
        return (ServerGUI)gui;
    }
    
}
